"""Copyright 2016-2017 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License."""


from traceutils.record.record import Record


class RegisterRecord(Record):
    """Register trace record."""

    REG = "register"
    VALUE = "value"

    def __init__(self, time, scale, register, value):
        """Default constructor."""
        Record.__init__(self, time, scale)
        self[self.REG] = register
        self[self.VALUE] = int(value, 16)

    def get_register(self):
        """Returns the register name."""
        return self[self.REG]

    def get_value(self):
        """Returns the hexadecimal value written to the register (64 bits maximum)."""
        return self[self.VALUE]
